package com.dx.union;

import cn.hutool.core.io.resource.ResourceUtil;
import cn.hutool.core.text.csv.CsvReader;
import cn.hutool.core.text.csv.CsvUtil;
import cn.hutool.http.HttpRequest;
import cn.hutool.json.JSONObject;
import cn.hutool.json.JSONUtil;
import org.apache.logging.log4j.LogManager;
import org.apache.logging.log4j.Logger;

import java.io.IOException;
import java.nio.charset.StandardCharsets;
import java.security.MessageDigest;
import java.util.List;
import java.util.Properties;

/**
 *
 */
public class CheckLogin {

    private static final Logger log = LogManager.getLogger(Main.class);
    private static final char[] HEX_CHARS = new char[]{'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'a', 'b', 'c', 'd', 'e', 'f'};

    public static void main(String[] args) {
        try {
            final CsvReader reader = CsvUtil.getReader();
            // Properties properties = getProperties();
            // String csv_file_path = properties.getProperty("csv_file_path");
            // log.info("csv_file_path:{}", csv_file_path);
            //假设csv文件在classpath目录下
            final List<User> userList = reader.read(
                    ResourceUtil.getUtf8Reader("users.csv"), User.class);
            log.info("读取到 {} 个需打卡账号", userList.size());
            userList.forEach(user -> {
                log.info("开始打卡 {} 的账号，密码为：{}", user.getUsername(), user.getPassword());
                boolean isSignSuccess = sign(user);
            });
        } catch (Exception e) {
            log.error(e);
        }

    }

    public static boolean sign(User user) {
        boolean result = false;
        try {
            String password = encrypt2ToMD5("weaver@2024");
            System.out.println(password);
            String username = "WBzhangmiao";
            String body = HttpRequest.post("https://login.oa.unionpay.com/idsapi/portal/Login")
                    .form("username", username)
                    .form("password", password)
                    .form("saveUsername", "false")
                    .form("savePassword", "false")
                    .form("loginType", "normal")
                    .form("code", "")
                    .execute().body();
            JSONObject bodyJson = JSONUtil.parseObj(body);
            String token = bodyJson.getJSONObject("data").getStr("token");
            String thirdBody = HttpRequest.get("http://oms.oa.unionpay.com/prod-api/checkTokenThenLogin?personType=0&token=" + token).execute().body();
            JSONObject thirdBodyJson = JSONUtil.parseObj(thirdBody);
            String thirdToken = thirdBodyJson.getStr("localToken");
            String resultBody = HttpRequest.post("http://oms.oa.unionpay.com/prod-api/atds/ds/1").header("Authorization", "Bearer " + thirdToken).execute().body();
            System.out.println(resultBody);
            result = true;
        } catch (Exception e) {
            log.error("sign error", e);
        }
        return result;
    }

    /**
     * MD5 加密
     * @param str 待加密字符串
     * @return MD5加密后字符串
     */
    public static String encrypt2ToMD5(String str) {
        // 加密后的16进制字符串
        String hexStr = "";
        try {
            // 此 MessageDigest 类为应用程序提供信息摘要算法的功能
            MessageDigest md5 = MessageDigest.getInstance("MD5");
            // 转换为MD5码
            byte[] digest = md5.digest(str.getBytes(StandardCharsets.UTF_8));
            hexStr = toHexString(digest);
        } catch (Exception e) {
            log.error("encrypt2ToMD5 error", e);
        }
        return hexStr;
    }

    public static String toHexString(byte[] input) {
        StringBuilder result = new StringBuilder();
        for (byte b : input) {
            result.append(HEX_CHARS[b >>> 4 & 15]);
            result.append(HEX_CHARS[b & 15]);
        }
        return result.toString();
    }

    public static Properties getProperties() throws IOException {
        Properties properties = new Properties();
        properties.load(ResourceUtil.getStream("config.properties"));
        return properties;
    }

}
